// Soubor DEDIC4.CPP
// Jednoduch pklad pouit virtulnch metod
// Program napodobuje grafick editor: Obsahuje hierarchii grafickch objekt
//
// Spolenm pedkem je tda GO (tj. grafick objekt), kter 
// implementuje spolen vlastnosti - barvu (jako slo typu unsigned long)
// pstupovou metodu Barva(), kter tuto barvy vrac, a metody
// Nakresli() a Smaz()
// Tyto metody jsou virtuln (kad grafick objekt se kresl - a tak mae - jinak
// Navc jsou ist virtuln (nemaj implementaci), nebo obecn grafick objekt nelze nakreslit
//
// Od tdy GO jsou odvozeny instann tdy bod a kruh
// tyto tdy maj navc datov sloky (souadnice bodu, sted a polomr kruhu)
// a implementuj metody Nakresli() a Smaz()
// specifikaci virtual nen v jejich deklaraci teba opakovat
//
// Abychom se vyhnuli technickm detailm kreslen (to C++ nee, to zvis na prosted, 
// pro kter je program uren), implementujeme tyto metody tak, e prost vypeme na obrazovku
// "kreslm bod..." , "kreslm kruh ..." 
//
// Program pracuje s dynamickmi instancemi td bod a kruh. Jejich adresy ukld do
// pole ukazatel na grafick objekty (tj. na typ GO)
// Polymorfizmus umouje nakreslit nebo smazat vechny objekty v jednom cyklu


#include <iostream.h>

class GO {
public:
	GO(unsigned long _barva):barva(_barva){}
	virtual void Nakresli() = 0;
	virtual void Smaz() = 0;
	virtual ~GO(){ cout << "rusim obecny GO" << endl;}
	unsigned long Barva() {return barva;}
private:
	unsigned long barva;
};

class bod: public GO {
	double x, y;		// Souadnice
public:
	bod(double _x, double _y, unsigned long _barva)
		: GO(_barva), x(_x), y(_y) {}
	~bod(){ Smaz(); }						// Specifikaci virtual nen teba opakovat
	void Nakresli()
	{
		cout << "kreslim bod" << "(" << x << ", " << y << ")"<< " barva: " << Barva()  << endl;
	}
	void Smaz()
	{
		cout << "mazu bod" << "(" << x << ", " << y << ")"<< " barva: " << Barva()  << endl;
	}
};

class kruh: public GO {
	double x, y, r;	// Souadnice stedu a polomr
public:
	kruh(double _x, double _y, double _r, unsigned long _barva)
		: GO(_barva), x(_x), y(_y), r(_r) {}
	~kruh(){ Smaz(); }
	void Nakresli()
	{
		cout << "kreslim kruh" << "(" << x << ", " << y << ", " << r << ")"<< " barva: " << Barva()  << endl;
	}
	void Smaz()
	{
		cout << "mazu kruh" << "(" << x << ", " << y << ", " << r << ")"<< " barva: " << Barva()  << endl;
	}
};


void main()
{
	GO *go[10];
	go[0] = new bod(1,1,0);
	go[1] = new kruh(2,5,8,9);
    int i;
	for(i = 0; i < 2; i++) go[i] ->Nakresli();
	for(i = 0; i < 2; i++) delete go[i];
}
