// Soubor CPLX2.CPP
// Petovn opertor pro tdu cplx - komplexn sla
// Chcete=li tento soubor pekldat na nkterm ze starch peklada, odstrate koment 
// u nsledujcho pkazu:
// typedef int bool;

// UNRN OPERTORY
// Opertor minus (unrn): vrt kopii instance s obrcenmi znamnky sloek
//    Je zde dvakrt, jednou jako metoda (uzaven do komente), podruh jako 
//    sptelen funkce - ob funguj, v programu sm bt ale jen jedna
// Opertor + (unrn): vrt aktuln instanci beze zmny
// Opertor !: vrt true, je-li re == 0 a zrove im == 0, jinak vrt false

// BINRN OPERTORY
// Opertor + (stn)
// Opertor * nsoben


#include <math.h>
class cplx {
public:
	cplx(double r=0, double i=0): re(r), im(i) {}
	double Re() { return re; }
	double Im() { return im; }
	friend double Abs(cplx& c) {return sqrt(c.re*c.re + c.im*c.im);}

	// UNRN OPERTORY
	// Opertor unrn minus (oto znamnka obou sloek)
	// jako metoda bez parametr
	//cplx operator-() { return cplx(-re, -im); }

	// Jin monost: sptelen funkce s jednm parametrem
	friend cplx operator-(cplx& c);
	
	bool operator!() { return !re && !im; }
	cplx operator+() { return *this; }

	// BINRN OPERTORY
	// Stn jako metoda: fungije, ale m sv problmy (viz kniha), pouijeme radji
	// sptelenou funkci
	// cplx operator+(cplx b) { return cplx(re+b.re, im+b.im);}
	friend cplx operator+(cplx a, cplx b);
	friend cplx operator*(cplx a, cplx b);
private:
	double re, im;
};

// Jin monost, jak deklarovat unrn minus pro komplexn sla
cplx operator-(cplx& c)
{
	return cplx(-c.re, -c.im);
}

// Jin monost, jak deklarovat stn pro komplexn sla


cplx operator*(cplx a, cplx b)
{
  return cplx(a.re*b.re - a.im*b.im, a.re*b.im+a.im*b.re);
}


cplx operator+(cplx a, cplx b)
{
	return cplx(a.re+b.re, a.im+b.im);
}

/*
// Znovu opertor stn, pochybn implementace
//NEFUNGUJE VE SLOITJCH VRAZECH - NEN REENTRANTN
cplx& operator+(cplx &a, cplx &b)
{
	static cplx pom;
	pom = cplx(a.re+b.re, a.im+b.im);
	return pom;
}
*/

void main()
{
	cplx a(1,1), b, i(0,1), j(1,0);
	b = -a;		// Vol se cplx::operator -()
	bool c = !a;
	c = !cplx(0,1);
	b = a+i;
	//b = a + 5;
	b = (a+j)*(i+j);
}
