// Soubor NEW2.CPP
// Opertor new peten jako metoda
//
// Typ strela pedstavuje stelu v njak potaov he.
// Stel je mnoho, ale ij jen krtce, proto se nechceme zatovat jejich
// alokac z voln pamti a nslednm uvolovnm. Stely alokujeme v arn, poli
// o dostaten velikosti, ve kterm se ukldaj jedna za druhou a 
// po vyerpn kapacitu arny zase od potku. Pitom doufme, e stely, 
// kter takto pepeme, u dvno neexistuj. K tomu si definujeme zvltn opertor new
// jako metodu typu strela.

#include <iostream.h>
#include <stddef.h>

class strela {
	enum {pocet = 1000};	// Maximln poet stel
	double x, y, rychlost;

	static char arena[];	// Pole pro alokaci stel
	static int index;		// Prbn index pro alokaci stel
	static const int velikost; // Velikost 1 stely v bajtech
public:
	strela(double xx=0, double yy=0, double rr=0)	// Konstruktor
		:x(xx), y(yy), rychlost(rr){}	
	void let();
	void * operator new(size_t s);					// Opertor new, kter alokuje stely do areny
	void * operator new[](size_t s);				// Poln verze opertoru new
};

void *strela::operator new(size_t s)
{
	int i = index;
	index += s;
	if(index < pocet*velikost)
		return &arena[i];
	else if(index == pocet*velikost)
	{
		index = 0;
		return &arena[i];
	}
	else
	{
		index = 0;
		return arena;
	}
}

char strela::arena[pocet*sizeof(strela)];		// Deklarace statickch sloek
int strela::index = 0;
const int strela::velikost = sizeof(strela);

void * strela::operator new[](size_t s)
{
	return operator new(s);
}

void main()
{
	for(int i = 0; i < 10; i++)					// Pklad pouit
	{
		strela* u = new strela;
		cout << u << endl;
	}
}