// Soubor T_SEZN1.CPP
// ablona objektovho typu: jednosmrn seznam se zarkou
// Parametr T uruje typ hodnot ukldanch do seznamu 

// Nejprve deklarujeme ablony prvku seznamu, typ prvek. 
// Ve td prvek<T> ovem chceme deklarovat tdu seznam<T>
// jako ptele, a protoe specifikace friend 
// nenahrazuje deklaraci typu (ani pedbnou), musme jako prvn uvst 
// pedbnou deklaraci ablony 
//
// Tda seznam obsahuje konstruktor, destruktor a metody
// - VlozNaKonec: Vlo zadanou hodnotu typu T na konec seznamu
// - Vyprzdni - odstran ze seznamu vechny prvky krom zarky
// - VyjmiPrvni - vyjme ze seznamu prvn prvek a vrt hodnotu v nm uloenou
// - Prazdny - vrt true, je-li seznam przdn, tj. obsahuje-li pouze zarku
//
// Dle obsahuje 
// statick atribut pocet, kter v kadm okamiku uruje poet existujcch 
// instanc tdy seznam,
// a statickou metodu Pocet(), kter vrac hodnotu atributu pocet.

#include <string>
#include <iostream>
#include <cstdlib>

using namespace std;

//template<class T> class seznam;	// Pedbn deklarace ablony

template<class T>
class prvek {						// Prvek seznamu
	T data;
	prvek* nasl;
	//friend class seznam<T>;			// Tda seznam sm poruovat pstupov prva
public:
	prvek(T t): data(t), nasl(0) {}
	T& hodnota() { return data; }   // Pstupov metody jsou referenn - lze je pout i
	prvek*& dalsi() { return nasl; }// k piazovn hodnot (zapsat na prav stran piazen)
};

template<class T>						// ablona tdy seznam
class seznam {
public:
	seznam();
	~seznam();
	void Vyprazdni();
	void VlozNaKonec(T co);
	T VyjmiPrvni();
	bool Prazdny() { return hlava == zarazka; }
	static int Pocet() { return pocet; }
private:
	prvek<T> *hlava, *zarazka;
	static int pocet;					// Aktuln poet seznam (instanc tdy seznam)
	void Chyba(string s){				// Primitivn oeten chyby
		cout << s << endl;
		exit(0);
	}
};


// ablona statickho atributu 
template<class T> int seznam<T>::pocet = 0;

// ablona konstruktoru
template<class T>
seznam<T>::seznam(): hlava(0), zarazka(0) {
	hlava = new prvek<T>(0);
	if(hlava) 
	{
		zarazka = hlava;
		pocet++;
	}
	else 
	{ 
		hlava = 0;
		Chyba("Nepodarila se alokace v konstruktoru");
	}
};

template<class T>
seznam<T>::~seznam() {
	Vyprazdni();
	delete zarazka;
	pocet--;
};

template<class T>
void seznam<T>::Vyprazdni(){
	prvek<T>* p = hlava;
	while(hlava != zarazka)
	{
		hlava = hlava->dalsi();
		delete p;
	}
};

template<class T>
void seznam<T>::VlozNaKonec(T co){
	zarazka -> hodnota() = co;
	zarazka -> dalsi() = new prvek<T>(0);
	if(!(zarazka -> dalsi())) Chyba("Nepodarila se alokace ve vloz()");
	zarazka = zarazka -> dalsi();
};

template<class T>
T seznam<T>::VyjmiPrvni()
{
	if(hlava == zarazka) Chyba("Vyber z prazdneho seznamu");
	prvek<T>* p = hlava;
	hlava = hlava -> dalsi();
	T t = p -> hodnota();
	delete p;
	return t;
};


void main()
{
	seznam<int> S, T, U;
	for(int i = 0; i < 10; i++)
		S.VlozNaKonec(i+5);
	while(!S.Prazdny())
		cout << S.VyjmiPrvni() << "  ";
	cout << endl;
	cout << "Pocet seznamu typu int: " << seznam<int>::Pocet() << endl;
	cout << "Pocet seznamu typu double: " << seznam<double>::Pocet() << endl;
}