// Soubor T_SEZNAM.CPP
// ablona objektovho typu: jednosmrn seznam se zarkou
// Parametr T uruje typ hodnot ukldanch do seznamu 
//
// Tda seznam obsahuje konstruktor, destruktor a metody
// - VlozNaKonec: Vlo zadanou hodnotu typu T na konec seznamu
// - Vyprzdni - odstran ze seznamu vechny prvky krom zarky
// - VyjmiPrvni - vyjme ze seznamu prvn prvek a vrt hodnotu v nm uloenou
//
// Dle obsahuje definici typu prvek (prvek seznamu, kter me obsahovat data typu T)
// a statick atribut pocet, kter v kadm okamiku uruje poet existujcch 
// instanc tdy seznam

#include <string>
#include <iostream>
#include <cstdlib>

using namespace std;

template<class T>						// ablona tdy seznam
class seznam {
public:
	class prvek {						// Vnoen typ - prvek seznamu
		T data;
		prvek* nasl;
		friend class seznam<T>;			// Tda seznam sm poruovat pstupov prva
	public:
		prvek(T t): data(t), nasl(0) {}
		T& hodnota() { return data; }   // Pstupov metody jsou referenn - lze je pout i
		prvek*& dalsi() { return nasl; }// k piazovn hodnot
	};

	seznam();
	~seznam();
	void vyprazdni();
	void VlozNaKonec(T co);
	T VyjmiPrvni();
private:
	prvek *hlava, *zarazka;
	static int pocet;					// Aktuln poet seznam (instanc tdy seznam)
	void Chyba(string s){				// Primitivn oeten chyby
		cout << s << endl;
		exit(0);
	}
};

// ablona statickho atributu (pesnji: specifikace implicitn hodnoty)
template<class T> int seznam<T>::pocet = 0;

// ablona konstruktoru
template<class T>
seznam<T>::seznam(): hlava(0), zarazka(0) {
	hlava = new prvek(0);
	if(hlava) 
	{
		zarazka = hlava;
		pocet++;
	}
	else 
	{ 
		hlava = 0;
		Chyba("Nepodarila se alokace v konstruktoru");
	}
};

template<class T>
seznam<T>::~seznam() {
	vyprazdni();
	delete zarazka;
	pocet--;
};

template<class T>
void seznam<T>::vyprazdni(){
	prvek* p = hlava;
	while(hlava != zarazka)
	{
		hlava = hlava->dalsi();
		delete p;
	}
};

template<class T>
void seznam<T>::VlozNaKonec(T co){
	zarazka -> hodnota() = co;
	zarazka -> dalsi() = new prvek(0);
	if(!(zarazka -> dalsi())) Chyba("Nepodarila se alokace ve vloz()");
	zarazka = zarazka -> dalsi();
};

template<class T>
T seznam<T>::VyjmiPrvni()
{
	if(hlava == zarazka) Chyba("Vyber z prazdneho seznamu");
	prvek* p = hlava;
	hlava = hlava -> dalsi();
	T t = p -> hodnota();
	delete p;
	return t;
};

void main()
{
	seznam<int> S;
	S.VlozNaKonec(10);
}