// Soubor APTR.CPP
// Pklad pouit automatickch ukazatel v souvislosti s vjimkami 
// 
// Tda X m konstruktor, kter pi parametru s hodnotou 11 
// vyvol vjimku
//
// Pozor, pro kontroln vstup v opertorech new a delete nepouvat 
// objektov datov proudy - hroz podivn chyby


#include <stdexcept>
#include <memory>
#include <string>
#include <cstdlib>
#include <cstdio>

using namespace std;

class X {
	int i;
public:
	X(int ii = 0): i(ii){
		printf("Konstruktor X(%d)\n", ii);
		if (ii == 11) throw logic_error("nezadouci hodnota i");
	}
	~X(){ printf("Destruktor X(%d)\n", i); }
};

void main()
{
	try {
		auto_ptr<X> u1(new X(1));
		auto_ptr<X> u2(new X(11));
	}
	catch(exception& e)
	{
		printf("Vyjimka: %s\n", e.what());
	}
}

/* Vstup tohoto programu bude

Konstruktor X(1)
Konstruktor X(11)
Destruktor X(1)
Vyjimka: nezadouci hodnota i

Instance *u1 se alokovala v podku a vytvoil se pro ni 
automatick ukazatel, kter pi vjimce pro tuto instanci 
zavol opertor delete (take se zavol destruktor a pak se uvoln pam).

Pro instanci *u2 se vyhradila pam a pak v konstruktoru vjimka.
destruktor se tedy nezavol (instance nen pln zkonstruovna),
automatick ukazatel se nevytvo, ale program automaticky zavol 
opertor delete.
*/