// Soubor NEWEX.CPP
// Pklad opertor new a delete se stejnmi dodatenmi parametry
// JEN NEJNOVJ PEKLADAE
// 
// Tda X m konstruktor, kter pi parametru s hodnotou 11 
// vyvol vjimku
//
// Opertor new m dodaten parametr typu unsigned char, kter 
// se pouije k inicializaci pamti instance.
// Opertor delete m t dodaten parametr.
// Dojde-li pi alokaci dynamick instance k vjimce, zavol se pro 
// uvolnn pamti alokovan pro nezkonstruovanou instanci automaticky 
// opertor delete s dodatenmi parametry stejnmi jako byly dodaten 
// parametry opertoru new.
//
// Pozor, pro kontroln vstup v opertorech new a delete nepouvat 
// objektov datov proudy - hroz podivn chyby

#include <stdexcept>
#include <string>
#include <cstdlib>
#include <cstdio>

using namespace std;

class X {
	int i;
public:
	X(int ii = 0): i(ii){
		printf("Konstruktor X(%d)\n", ii);
		if (ii == 11) throw logic_error("nezadouci hodnota i");
	}
	~X(){ printf("Destruktor X(%d)\n", i); }
};

void *operator new(size_t s, unsigned char co)
{
	void *p = malloc(s);
	memset(p, co, s);
	printf("Operator new\n");
	return p;
}

void operator delete(void* p, unsigned char co)
{
	printf("Operator delete\n");
	free(p);
}

void main()
{
	try {
		X* u1 = new(0xff) X(1);
		delete u1;
		X* u2 = new(0xff) X(11);
	}
	catch(exception& e)
	{
		printf("Vyjimka: %s\n", e.what());
	}
}

/* Vstup dohoto programu bude
Operator new
Konstruktor X(1)
Destruktor X(1)
Operator new
Konstruktor X(11)
Operator delete
Vyjimka: nezadouci hodnota i


Vimnte si, e se neuvolnila pam pro prvn instanci,
kter se v podku zkonstruovala, ale jen pro druhou instanci,
pro kterou se sice alokovala pam, ale v konstruktoru
vznikla vjimka.
Vimnte si tak, e pkazem
delete u1 
se nezavolal n opertor delete, ale standardn verze
tohoto opertoru.
*/