// Soubor RETHROW.CPP
// Pklad stenho oeten vjimky
// 
//Funkce Uloz(S, Kolik, Soubor) m za kol vyjmout Kolik prvk seznamu  
// S a uloit je do souboru Soubor.
// Pouijeme neobjektov nstroje ze <stdio.h>.
//
// Jednotliv prvky ze seznamu vybrme pomoc metody S.VyjmiPrvni, kter
// me vyvolat vjimku chyba_seznamu. Kdyby k takov vjimce ale dolo, zstal
// by soubor Soubor oteven, a to nechceme. Proto vjimku
// zachytme, v handleru soubor uzaveme a pak vjimku poleme dl.
//
// Elegantnj een zaloen na objektovch datovch proudech, kter
// nepotebuje zachycovat vjimku a pak ji poslat dl, ukazuje funkce Uloz2():
// Vytvome proud (objekt typu ofstream z hlavikovho souboru <fstream>), 
// vybrme prvky jeden po druhm a ukldme je do souboru pomoc
// metody write. Pokud vznikne vjimka, zavol se automaticky destruktor 
// proudovho objektu a ten soubor uzave. 
// (Destruktor uzave soubor i v ppad, e vjimka nevznikne a funkce
// Uloz2() skon normln.)

#include "seznam.h"
#include <stdio.h>
#include <fstream>

// Vyjmut prvnch Kolik prvk ze seznamu a zpis do souboru
void Uloz(seznam<int> &S, int Kolik, const char* Soubor) throw (chyba_seznamu)
{
	FILE *f;
	f = fopen(Soubor, "ab");	// Otevi soubor v binrnm reimu
	if(!f) return;				// Kdy se to nepovede, konec
	try {						
		for(int i = 0; i < Kolik; i++)
		{						// Zkus vyjmout prvek a zapsat ho do souboru
			int j = S.VyjmiPrvni();
			fwrite(&j, sizeof(j), 1, f);
		}
	}
	catch(chyba_seznamu)		// a kdy se to nepovede
	{
		fclose(f);				// uzavi soubor 
		cout << "Neco se deje" << endl;
		throw;					// a poli vjimku dl.
	}
}

// Elegantnj een pomoc objektovch proud
void Uloz2(seznam<int> &S, int Kolik, const char* Soubor) throw (chyba_seznamu)
{
	ofstream f(Soubor, ios::app|ios::binary);	// Vytvo proud pro pipisovn na konec, v binrnm reimu
	if(!f) return;					// Kdy se to nepovede, konec
	for(int i = 0; i < Kolik; i++)
	{
		int j = S.VyjmiPrvni();					// Vyjmi prvek a zapi ho
		f.write((const char*)&j, sizeof(j));
	}											// Zde se o vjimky nestarme. Kdy se to
}					// nepovede, destruktor soubor uzave.


void main()
{
	seznam<int> S;
	for(int i = 0; i < 5; i++)
		S.VlozNaPocatek(i);
	try {
		Uloz(S, 10, "data.dta");
	}
	for(int i = 0; i < 5; i++)
		S.VlozNaPocatek(i);
	try {
		Uloz2(S, 10, "data.dta");
	}
	catch(exception& e)
	{
		cout << "Vyjimka: " << e.what() << endl;
	}
}