// Soubor VYJIMKA1.CPP
// Prvn pklad pouit vjimek
//
// Tda A m konstruktor a destruktor, kter vypisuj hlen,
// To je jejich jedin el.
//
// Funkce f vyvol vjimku, je-li parametr roven 1.
//
// Ve funkci main v pokusnm bloku nejprve deklarujeme 
// instanci a tdy A, pak v cyklu volme funkci f.
//
// Bh programu vypad takto:
// - Po vstupu do pokusnho bloku (blok try) se vytvo instance y tdy A
//   a konstruktor o tom vype zprvu.
// - Pak zane cyklus for. Pi prvnm prchodu se zavol funkce f(0),
//   v n se vytvo instance x tdy A, otestuje se podmnka, ta nen splnna,
//   vype se hlen,
//   instance x zanikne (destruktor o tom vype zprvu) a program se vrt z f.
// - Pak se zavol f(1). Vytvo se instance x tdy A a probhne pkaz throw, nebo 
//   je splnna podmnka i == 1. Zavol se destruktor instance x a program odejde z f.
//   Hlen se nevype, nebo pkazy od msta, kde vznikla vjimka, do konce bloku se pesko.
// - Vjimka se roz do funkce main. Zbytek pokusnho bloku se ji neprovede, to znamen, e 
//   iterace cyklu for pro i == 3, ..., 10 a nsledujc vstup neprobhnou.
// - Program pejde do handleru a pak pokrauje za nm.
//
// ZA TEXTEM PROGRAMU NSLEDUJE VSATUP PROGRAMU A NVOD K NKOLIKA EXPERIMENTM
//

#include <iostream>
#include <exception>

using namespace std;

class A
{
	int i;
public: 
	A(int a): i(a){cout << "konstruktor A " << i << endl;}
	~A(){cout << "destruktor A " << i << endl;}
};

void f(int i)
{
	A x(i);
	if (i == 1) throw logic_error("POMOC!!! i == 2");
	cout << "funkce f, i == " << i << endl;
}


void main()
{
	try {
		A y(99);
		for(int i = 0; i < 10; i++) f(i);
		cout << "jsme zde" << endl;
	}
	catch(logic_error e)
	{
		cout << "logick chyba: " << e.what() << endl;
	}
	cout << "Pokracujeme za vyjimkou" << endl;
}

/***********************************************
Vstup tohoto programu je (komente k nmu nepat)

konstruktor A 99	// Konstrukce y
konstruktor A 0		// Konstrukce x pi prvnm vstupu do f
funkce f, i == 0	// Za mstem, kde me vzniknout vjimka ve funkci f
destruktor A 0		// Znik instance x pi vstupu z f
konstruktor A 1		// Konstrukce x pi druhm vstupu do f
destruktor A 1		// Znik x po vzniku vjimky
destruktor A 99		// Znik y po rozen vjimky do pokusnho bloku
Vyjimka: POMOC!!! i == 2// V handleru
Pokracujeme za vyjimkou	// Program pokrauje za handlerem


Nmty k pokusm:
1. Zmte typ vjimky v handleru na exception. Vstup programu (a jeho bh) se nezmn.
2. Zmte podmnku ve funkci f tak, aby k vjimce nedolo.
3. Za blok try pipojte msto stvajcho tyto dva handlery :
	catch(logic_error e)
	{
		cout << "logick chyba: " << e.what() << endl;
	}
	catch(exception e)
	{
		cout << "Obecn vyjimka: " << e.what() << endl;
	}
   Zkuste, jak to dopadne, jestlie funkce f vyvol vjimku 
   logic_error, exeption nebo runtime_error.
   (V poslednm ppad program skon chybovm hlenm 
   "Abnormal program termination" nebo podobnm.
4. Za blok try pipojte tyt handlery v opanm poad:
	catch(exception e)
	{
		cout << "Obecn vyjimka: " << e.what() << endl;
	}
	catch(logic_error e)
	{
		cout << "logick chyba: " << e.what() << endl;
	}
   Peklada nejsp vype varovn, ale program pelo. Ovem a 
   vznikne ve funkci f vjimka logic_error, exeption nebo runtime_error,
   zachyt ji prvn handler (s parametrem typu exception).
*/