// Soubor DCAST1.CPP
// Pklady ukazujc fungovn opertoru dynamic_cast
//
// Nejprve tdy, na kterch to budeme pedvdt - mus bt polymorfn,
// tak jim dme virtuln destruktor; metoda hodnota nen virtuln

#include <typeinfo>
#include <iostream>
using namespace std;

class A {
	int a;
public:
	A(int i): a(i){}
	virtual ~A() {}
	int hodnota() { return a; }
};

class B {
	int b;
public:
	B(int i): b(i){}
	virtual ~B() {}
	int hodnota() { return b; }
};

// C je spolenm (jednoznanm a pstupnm) potomkem A a B

class C: public A, public B
{
	int c;
public: 
	C(int c): A(c), B(c+1), c(c+2) {}
	int hodnota() { return c; }
};

void main()
{
	A a(1); // Instance
	B b(2);
	C c(3);
	A* ua;	// Ukazatele na instance
	B* ub;
	C* uc = &c;
	
// Nejprve pklady, kde je pouit opertoru dynamic_cast dovolen, ale zbyten
//
	ua = dynamic_cast<A*>(uc);	// Petypovn na pedka: dovolen, i kdy zbyten
	ua = uc;					// Znamen naprosto tot co pedchoz pkaz 
							// nebo ua = (A*)uc;
							// nebo ua = static_cast<A*>(uc);

	int i = dynamic_cast<A&>(c).hodnota();		// Zpsob tot co nsledujc pkazy
	i = ((A&)c).hodnota();				// Tot co pedchoz pkaz
	i = static_cast<A&>(c).hodnota();		// Tot
	i = c.A::hodnota();				// Tot bez petypovn

// Trochu uitenj petypovn: Konverze na void*
	ub = uc;					// ub ukazuje na zddn podobjekt typu B v c
	void *v1 = dynamic_cast<void*>(ub);		// v1 obsahuje adresu c
	void *v2 = static_cast<void*>(ub);		// v2 obsahuje adresu zddnho podpobjektu typu B, v1 != v2
	cout << ((v1 == v2) ? "Ano" : "Ne") << endl;	// Vype Ne

// Petypovn na potomka
	ub = uc;					// ub ukazuje na zddn podobjekt typu B v c

	C* ucc = dynamic_cast<C*>(ub);			// Petypovn se poda, nebo ub obsahuje adresu zddnho podobjektu v instanci tdy C
	if(ucc)						// Je teba kontrolovat, zda se to podailo
		cout << ucc -> hodnota() << endl;
	else
		cout << "nepovedlo se" << endl;

	ub = &b;					// ub ukazuje na samostatnou instanci

	ucc = dynamic_cast<C*>(ub);			// Petypovn se nepoda, nebo ub obsahuje adresu samostatn instance tdy B
	if(ucc)						// Je teba kontrolovat, zda se to podailo
		cout << ucc -> hodnota() << endl;	// Vype 5
	else
		cout << "nepovedlo se" << endl;		// a tentokrt se dozvme, e ne

// Tot pro reference
	B &rb = c;					// rb je odkaz na zddn podobjekt tdy B v instanci c
	cout << rb.hodnota() << endl;			// Vype 4
	
	try {
		cout << dynamic_cast<C&>(rb).hodnota() << endl;	// Vype 5, nebo rb je reference na zddn podobjekt v instanci typu C
		cout << dynamic_cast<C&>(b).hodnota() << endl;	// Nepovede se, nebo b je samostatn instance - vznikne vjimka
	}
	catch(...)
	{
		cout << "Pretypovani se nepovedlo" << endl;
	}

// Petypovn na z pedka na jinho nezvislho pedka

	ub = uc;					// ub ukazuje na zddn podobjekt typu B v c
	ua = dynamic_cast<A*>(ub);			// Lze - ub obsahuje adresu zddnho podobjektu tdy, kter m za pedka tak A
	if(ua)
		cout << ua->hodnota() << endl;		// Vype 3  (Je rozumn opt zjiovat, zda se petypovn podailo.)

	ua = &a;					// Nyn obsahuje ua adresu samostatn instance
	ub = dynamic_cast<B*>(ua);			// take toto petypovn se nepovede
	if(ub)
		cout << ub->hodnota() << endl;		
	else
		cout<< "Pretypovani se nepovedlo" << endl;

	ub = (B*)(C*)ua;				// Klasick cesta
	cout << ub->hodnota() << endl;			// Vype njak nesmysl, nebo ua ukozovalo na samostatnou instanci a petupovn na B* nemlo smysl
}
