// Soubor SCAST1.CPP
// Pklady ukazujc fungovn opertoru static_cast
//
// Nejprve tdy, na kterch to budeme pedvdt 

#include <iostream>
using namespace std;

class A {					// tda A obsahuje konverzn metodu operator int()
	int a;
public:
	A(int i): a(i){}
	virtual ~A() {}
	int hodnota() { return a; }
	operator int&() {return a;}
};

class B {
	int b;
public:
	B(int i): b(i){}
	virtual ~B() {}
	int hodnota() { return b; }
};

enum dny {po, ut, st, ct, pa, so, ne};

// C je spolenm (jednoznanm a pstupnm) potomkem A a B

class C: public A, public B
{
	int c;
public: 
	C(int c): A(c), B(c+1), c(c+2) {}
	int hodnota() { return c; }
};

A a(1); // Instance
B b(2);
C c(3);
A* ua;	// Ukazatele na instance
B* ub;
C* uc = &c;

void main()
{
// static_cast a bn petypovn neobjektovch typ
	double d = 55.2;
	dny dn;
	int i;

	i = static_cast<int>(d);	// Petypovn, kter me probhnout automaticky
	dn = static_cast<dny>(2);	// Petypovn na vtov typ

// static_cast zavol konverzn funkci
	int &rint = static_cast<int&>(a);	// tot jako int& rint = (int&)a;
	rint = 33;							// Piazen do sloky a.a
	cout << a.hodnota() << endl;		// Vype 33

	int j = static_cast<int>(a);		// Opt se pouije konverzn opertor

// Konverze objektovch typ a ukazatel na n

// Petypovn na pedka
	ua = static_cast<A*>(uc);	// Petypovn na pedka: dovolen, i kdy zbyten
	ua = uc;					// Znamen naprosto tot co pedchoz pkaz 
								// nebo ua = (A*)uc;
								// nebo ua = static_cast<A*>(uc);

	i = ((A&)c).hodnota();				// Tot co nsledujc pkaz
	i = static_cast<A&>(c).hodnota();		// Tot
	i = c.A::hodnota();						// Tot bez petypovn


// Petypovn na potomka
	ub = uc;								// ub ukazuje na zddn podobjekt typu B v c

	C* ucc = static_cast<C*>(ub);			// Konverze na ukazatel na potomka rmci hierarchie 
	cout << ucc -> hodnota() << endl;		// Vype 5

	ub = &b;								// ub ukazuje na samostatnou instanci

	ucc = static_cast<C*>(ub);				// Petypovn nem smysl,ub obsahuje adresu samostatn instance tdy B
	cout << ucc -> hodnota() << endl;		// Vype njak nesmysl

// Tot pro reference
	B &rb = c;								// rb je odkaz na zddn podobjekt tdy B v instanci c
	cout << rb.hodnota() << endl;			// Vype 4
	
	cout << static_cast<C&>(rb).hodnota() << endl;	// Vype 5, nebo rb je reference na zddn podobjekt v instanci typu C
	cout << static_cast<C&>(b).hodnota() << endl;	// Vype njak nesmysl, nebo petypovn nem smysl

// Petypovn na z pedka na jinho nezvislho pedka

	ub = uc;								// ub ukazuje na zddn podobjekt typu B v c
	//ua = static_cast<A*>(ub);				// Chyba: tohle static_cast neum
	ua = static_cast<A*>(static_cast<C*>(ub));	// Takhle to jde obejt, ale bez dynamick kontroly typ  
	cout << ua->hodnota() << endl;			// Vype 3
}