// Soubor NSP4.CPP
// Pklad vyhledvn opertor v prostorech jmen
//
// Program obsahuje dva prostory jmen Complex a Real
// V prvnm je deklarovna tda Cplx vyjadujc komplexn sla a
// opertor pro ctn dvou komplexnch sel,
// ve druhm tda Double zapouzdujc typ double
// a opertor pro stn typu Cplx a Double (v tomto poad)
//
// Ve funkci main() je deklarovno nkolik instanc a vypoteny souty
// Cplx + Cplx a Cplx + Double.
// Oba peklada zvldne, nebo opertory jsou deklarovny 
// v prostorech jmen operand

// Protoe deklarace opertor na sob zvis, deklarujeme nejprve 
// prostory jmen a pedbn deklarace td a opertor

namespace Complex { class Cplx; Cplx operator+(Cplx, Cplx); }
namespace Real{ class Double; Complex::Cplx operator+(Complex::Cplx, Double); }

// Komplexn sla
namespace Complex {
	class Cplx {
		double re, im;
	public:
		Cplx(double _re = 0, double _im = 0): re(_re), im(_im){}
		friend Cplx operator +(Cplx, Cplx);
		friend Cplx Real::operator+(Complex::Cplx, Double);
	};

	Cplx operator +(Cplx a, Cplx b)
	{
		return Cplx(a.re+b.re, a.im+b.im);
	}
}


// Reln sla
namespace Real {
	class Double {
		double d;
	public:
		Double(double _d): d(_d){}
		friend Complex::Cplx operator + (Complex::Cplx c, Double d)
		{
			return Complex::Cplx(d.d+c.re, c.im);
		}
	};

}

// Pouit obou opertor: jsou deklarovny v kontextu operand
void main()
{
	Complex::Cplx a(2,3), b(5,8), c;
	Real::Double d(5);
	c = a+b;	// Opertor bude nalezen v prostoru Complex
	c = c+d;	// Opertor bude nalezen v prostoru Real
}

