// Soubor IO2.CPP
// Proud jako parametr, vstup do souboru
//
// Funkce Tab je stejn jako v souboru IO1.CPP, a na to,
// e jejm prvnm parametrem je odkaz na instanci typu ostream
// To umouje pedat jako skuten parametr libovoln vstupn proud
//
// Vstup do souboru: ve funkci main() definujeme instanci F typu fstream
// (souborov proud pro vstup i vstup).
// Prvn parametr konstruktoru je jmno souboru, 
// druh parametr je reim oteven - uruje ho vtov typ, 
// definovan ve td ios. Hodnota ios::out pedepisuje oteven pro vstup.
// (Pznaky tohoto vtovho typu lze spojovat pomoc opertoru |.)
// Tento konstruktor automaticky proud tak oteve.
//
// Pomoc petenho opertoru ! testujeme, zda se oteven podailo.
// Pokud ne, volme funkci Chyba().
// Po nvratu z funkce Tab() proud uzaveme pomoc metody close. (Zde to je zbyten, 
// o uzaven by se tak jako tak postaral destruktor.
// Ostatn zachzen s proudem F je stejn jako v ppad proudu cout. 

#include <iomanip>
#include <iostream>
#include <fstream>
#include <math.h>
#include <stdlib.h>

using namespace std;

void Chyba(){ // Primitivn oeten chyby: hlen a konec programu
	cerr << "Nejde otevrit soubor" << endl;
	exit(0);
}

void Tab(ostream& Proud, const char* s, double (*f)(double))
{
	Proud << "Tabulka funkce " << s << endl;
	Proud << "-------------------" << endl;
	Proud << setw(5) << "x" << setw(8) << s << "(x)" << endl;
	Proud << "-------------------" << endl;
	Proud << setprecision(5) << fixed << showpoint;
	for(int i = 0; i <= 10; i++)
	{
		double x = i/10.0;
		Proud << setw(5) << x << setw(10) << f(x) << endl;
	}

}

void main()
{
	fstream F("data.dta", ios_base::out);	// Vytvo proud a otevi soubor
	if(!F)									// Pokud se to nepoda, volej chybovou funkci
	  Chyba();
	
	Tab(F, "sin", sin);						// Proud jako parametr funkce

	F.close();	// Zde zbyten, udlal by to automaticky volan destruktor
}

