// Soubor IO5.CPP
// Pklad aktualizace souboru
// Funkce VytvorSoubor() vytvo binrn soubor data.dta obsahujc cel sla 0 .. 9
// Funkce VypisSoubor() vype zadan soubor celch sel na obrazovku
//
// Funkce Aktualizuj() projde zadan soubor, vyhled v nm sud sla a nahrad je polovin hodnotou
// - nejprve vytvo vstupn-vstupn proud F,
// - pak v cyklu vdy pete jeden zznam do promnn i,
// - je-li to sud slo, vydl ho dvma,
// - pomoc tellg() zjist aktuln vstupn pozici a nastav aktuln vstupn pozici o sizeof(i) men
// - zape i pomoc metody write().

#include <fstream>
#include <iostream>
#include <stdlib.h>

using namespace std;

const char * Jmeno = "data.dta";

void Chyba()
{
	cerr << "nepodarilo se otevrit soubor" << endl;
	exit(1);
}

void VytvorSoubor(const char* jmeno)
{
	ofstream F(jmeno);
	for(int i = 0; i < 10; i++)
		F.write((char*)&i, sizeof(i));
}

void VypisSoubor(const char* Jmeno)
{
	ifstream F(Jmeno);
	if(!F) Chyba();
	int i;
	while(F.read((char*)&i, sizeof(i)))
		cout << i << endl;

}

void Aktualizuj(const char *Jmeno)
{
  fstream F(Jmeno, ios::in | ios::out | ios::binary);// Vytvo proud pro vstup a vstup, binrn
  if(!F) Chyba();

  int i;				// Do i teme
  while(F.read((char*)&i, sizeof(i)))	// Peti zznam
  {
          //if(!F) Chyba();
          if(!(i & 1))			// Je-li slo sud
          {
                  i /= 2;		// akyualizuj ho
                  F.seekp(F.tellg() -(long)sizeof(int), ios::beg); // Nastav pozici ve vstupu
                  F.write((char*)&i, sizeof(i));	// a zapi novou hodnotu
          }	// F.tellp();	// Tohle poaduje Visual C++ 6.0, jinak v nm program nechod	
  }
}

void main()
{
        VytvorSoubor(Jmeno);
	VypisSoubor(Jmeno);
        Aktualizuj(Jmeno);
	VypisSoubor(Jmeno);
}